// Control.cpp: implementation of the CControl class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DirectDraw.h"
#include "Control.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define RES_X			640
#define RES_Y			480
#define RES_BITDEPTH	16
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CControl::CControl()
{
	m_lpDD = NULL;
}

CControl::~CControl()
{
	if(m_lpDD) {
		m_lpDD->RestoreDisplayMode();
		m_lpDD->Release();
		m_lpDD = NULL;
	}
}

HRESULT CControl::DDInit(HWND hWnd)
{
    HRESULT dwResult;

    // DirectDraw object creation
    dwResult = DirectDrawCreateEx(NULL, (void**)&m_lpDD, IID_IDirectDraw7, NULL);
    if(dwResult != DD_OK) {
        TRACE("Cannot create direct draw object due %d\n", dwResult);
        return dwResult;
    }

    // Setting cooperative level
    dwResult = m_lpDD->SetCooperativeLevel(hWnd, DDSCL_EXCLUSIVE|
                                                DDSCL_FULLSCREEN|
                                                DDSCL_ALLOWREBOOT);
    if(dwResult != DD_OK) {
        TRACE("Cannot set cooperative level due %d\n", dwResult);
        return dwResult;
    }

    // Setting display mode
    dwResult = m_lpDD->SetDisplayMode(RES_X,RES_Y, RES_BITDEPTH, 0, 0);
    if(dwResult != DD_OK) {
        TRACE("Cannot set display mode due %d\n", dwResult);
        return dwResult;
    }

    return dwResult;
}
